#include "defines.h"
#include "IO.h"

#define CHECK_IMPROVEMENT     0

int pattern9x9Sym[] = {
    0,  1,  2,  3,  4,  3,  2,  1,  0,
    5,  6,  7,  8,  9,  8,  7,  6,  5,   
    10, 11, 12, 13, 14, 13, 12, 11, 10,
    15, 16, 17, 18, 19, 18, 17, 16, 15,      
    20, 21, 22, 23, 24, 23, 22, 21, 20, 
    15, 16, 17, 18, 19, 18, 17, 16, 15, 
    10, 11, 12, 13, 14, 13, 12, 11, 10,
    5,  6,  7,  8,  9,  8,  7,  6,  5, 
    0,  1,  2,  3,  4,  3,  2,  1,  0
};

int weights9x9Sym[] = {
  4,  4,  4,  4,  2,  
  4,  4,  4,  4,  2,   
  4,  4,  4,  4,  2,  
  4,  4,  4,  4,  2,  
  2,  2,  2,  2,  1, 1
};

int pattern9x9Sym_Quart[] = {
  1,  2,  3,  4,  5,  
  6,  7,  8,  9, 10,  
  11, 12, 13, 14, 15, 
  16, 17, 18, 19, 20, 
  21, 22, 23, 24, 25, 26
};

int pattern7x7Sym[] = {
    0,  1,  2,   3,  2, 1,  0,
    4,  5,  6,   7,  6, 5,  4, 
    8,  9, 10,  11, 10, 9,  8,
    12, 13, 14, 15, 14, 13, 12,
    8,  9, 10,  11, 10, 9,  8,
    4,  5,  6,   7,  6, 5,  4,
    0,  1,  2,   3,  2, 1,  0
};

int weights7x7Sym[] = {
  4,  4,  4,  2,  
  4,  4,  4,  2,   
  4,  4,  4,  2,   
  2,  2,  2,  1, 1
};

int pattern7x7Sym_Quart[] = {
  0,  0,  0,  0,   0,  
  0,  1,  2,  3,   4,  
  0,  5,  6,  7,   8,  
  0,  9, 10, 11,  12, 
  0, 13, 14, 15,  16, 17
};

int pattern5x5Sym[] = {
    0,  1,  2, 1, 0,  
    3,  4,  5, 4, 3,   
    6,  7,  8, 7, 6, 
    3,  4,  5, 4, 3,
    0,  1,  2, 1, 0
};

int weights5x5Sym[] = {
  4,  4,  2,  
  4,  4,  2,   
  2,  2,  1, 1
};

int pattern5x5Sym_Quart[] = {
  0,  0,  0,  0,   0, 
  0,  0,  0,  0,   0,  
  0,  0,  1,  2,   3,  
  0,  0,  4,  5,   6,  
  0,  0,  7,  8,   9, 10
};

int *patternTab[NO_TEST_FILT]={pattern9x9Sym, pattern7x7Sym, pattern5x5Sym}; 
int *patternMapTab[NO_TEST_FILT]={pattern9x9Sym_Quart, pattern7x7Sym_Quart, pattern5x5Sym_Quart};
int *weightsTab[NO_TEST_FILT]={weights9x9Sym, weights7x7Sym, weights5x5Sym};
int sqrFiltLengthTab[]={SQR_FILT_LENGTH_9SYM, SQR_FILT_LENGTH_7SYM, SQR_FILT_LENGTH_5SYM};
int flTab[]={9/2, 7/2, 5/2};

results psnrBitsRes;

//
//
//
void cutEy(double **E, double *y, double **E_merge, double *y_merge, int sqrFiltLength, int pattern[])
{
  int i, j;

  for(i = 0; i < sqrFiltLength; i++)
  {
    y_merge[pattern[i] - 1] = y[i];
    for(j = 0; j < sqrFiltLength; j++)
      if((pattern[i] > 0) && (pattern[j] > 0))
        E_merge[pattern[i] - 1][pattern[j] - 1] = E[i][j];
  }
}


//
//  Prediction  
//
double testPrevFilterFast(double ***A, double **b, double *pixAcc, double **filterCoeffSym, int usePrevFilt[])
{
  int i;
  double seFilt[NO_VAR_BINS] = {0}, seOrig[NO_VAR_BINS] = {0}, error;
  int sqrFiltLength = MAX_SQR_FILT_LENGTH;

  for(i = 0; i < NO_VAR_BINS; i++)
  {
    seOrig[i] = pixAcc[i];
    seFilt[i] = pixAcc[i] + calculateErrorCoeffProvided(A[i], b[i], filterCoeffSym[i], sqrFiltLength);
  }

  error = 0;
  for(i = 0; i < NO_VAR_BINS; i++)
  {
    if(seFilt[i] < seOrig[i])
    {
      usePrevFilt[i] = 1;
      error += seFilt[i];
    }
    else
    {
      usePrevFilt[i] = 0;
      error += seOrig[i];
    } 
  }
  return(error);
}

//
//
//
double testPrevFilterFastTestCopy(double ***A, double **b, double *pixAcc, double **filterCoeffSym, int usePrevFilt[])
{

  int i;
  double seFilt[NO_VAR_BINS]={0}, seOrig[NO_VAR_BINS]={0}, error;
  int sqrFiltLength=MAX_SQR_FILT_LENGTH;

  for (i=0; i<NO_VAR_BINS; i++){
    seOrig[i]=pixAcc[i];
    seFilt[i]=pixAcc[i]+calculateErrorCoeffProvided(A[i], b[i], filterCoeffSym[i], sqrFiltLength);
  }

  error=0;
  for (i=0; i<NO_VAR_BINS; i++){
    if (usePrevFilt[i]==1){
      usePrevFilt[i]=1;
      error+=seFilt[i];
    }
    else{
      usePrevFilt[i]=0;
      error+=seOrig[i];
    } 
  }
  return(error);
}

//
//
//
double testPrevFilter(imgpel **imgY_rec, imgpel **imgY_org, imgpel **imgY_pad, imgpel **varImg, 
                    double **filterCoeffSym, int usePrevFilt[], int img_height, int img_width)
{
  int i, j, ii, jj, k, vectorInd, varInd, pixelInt, temp;
  double seFilt[NO_VAR_BINS] = {0}, seOrig[NO_VAR_BINS] = {0}, pixelDouble, error;
  int sqrFiltLength = MAX_SQR_FILT_LENGTH,  fl = FILTER_LENGTH/2;
  int *pattern = pattern9x9Sym;

  for(i = fl; i < img_height+fl; i++)
  {
    for(j = fl; j < img_width+fl; j++)
    {
      varInd = min(varImg[i - fl][j - fl], NO_VAR_BINS - 1);
      pixelDouble = 0; 
      k = 0;

      for(ii = i - fl; ii <= i + fl; ii++)
      {
        for(jj = j - fl; jj <= j + fl; jj++)
        {  
          vectorInd = pattern[k++];
          pixelDouble += (imgY_pad[ii][jj] * filterCoeffSym[varInd][vectorInd]);
        }
      }
      pixelDouble += filterCoeffSym[varInd][sqrFiltLength - 1];
      pixelInt = (int)floor(pixelDouble + 0.5);
      pixelInt = Clip3Fun(0, 255, pixelInt);

      temp = (pixelInt - imgY_org[i - fl][j - fl]);
      seFilt[varInd] += temp * temp;
      temp = (imgY_rec[i - fl][j - fl] - imgY_org[i - fl][j - fl]);
      seOrig[varInd] += temp * temp;
    }
  }

  error = 0;
  for(i = 0; i < NO_VAR_BINS; i++)
  {
    if(seFilt[i] < seOrig[i])
    {
      usePrevFilt[i] = 1;
      error += seFilt[i];
    }
    else
    {
      usePrevFilt[i] = 0;
      error += seOrig[i];
    } 
  }
  return(error);
}

//
//
//
void preFilterFr(double **imgY_preFilter, imgpel **imgY_rec, imgpel **imgY_org, imgpel **imgY_pad, imgpel **varImg,  
                 double **filterCoeffSym, int usePrevFilt[], int img_height, int img_width)
{
  int i, j, ii, jj, k, vectorInd, varInd, temp;
  double pixelDouble, seFilt = 0, seOrig = 0;
  int sqrFiltLength = MAX_SQR_FILT_LENGTH,  fl = FILTER_LENGTH/2;
  int *pattern = pattern9x9Sym;

  for(i = fl; i < img_height + fl; i++)
  {
    for(j = fl; j < img_width+fl; j++)
    {
      varInd = min(varImg[i - fl][j - fl], NO_VAR_BINS - 1);
      if(usePrevFilt[varInd] == 1)
      {
        pixelDouble = 0; 
        k = 0;
        for(ii = i - fl; ii <= i + fl; ii++)
        {
          for(jj = j - fl; jj <= j + fl; jj++)
          {  
            vectorInd = pattern[k++];
            pixelDouble += (imgY_pad[ii][jj] * filterCoeffSym[varInd][vectorInd]);
          }
        }
        pixelDouble += filterCoeffSym[varInd][sqrFiltLength - 1];
        imgY_preFilter[i - fl][j - fl] = pixelDouble;
      }
      else
      {
        imgY_preFilter[i - fl][j - fl] = imgY_rec[i - fl][j - fl];
      }

      temp = (int)Clip3Fun(0, 255, ROUND(imgY_preFilter[i - fl][j - fl]));
      temp = (temp - imgY_org[i - fl][j - fl]);
      seFilt += temp * temp;
      temp = (imgY_rec[i - fl][j - fl] - imgY_org[i - fl][j - fl]);
      seOrig += temp * temp;
    }
  }
}

//
//
//
double findBestFilterVarPred(Bitstream *bitstream, imgpel **imgY_rec, imgpel **imgY_org, imgpel **varImg, 
                             int frNo, int qp, int *filtNo_best, double **filterCoeffSym, int varIndTab[], 
                            int usePrevFiltBest[], int *prevFiltInd, int *forceCoeff0, int *codedFlag, 
                            int img_height, int img_width)
{
  int filters_per_fr, filters_per_fr_best, firstFilt, filtNo, coded,
    interval[NO_VAR_BINS][2], intervalBest[NO_VAR_BINS][2];
  int i, j, ii, jj, k, l, varInd, vectorInd, ELocal[MAX_SQR_FILT_LENGTH], pixelInt;
  static double ***yGlobalSym, ****EGlobalSym, *filterCoeffDefault, ***filterCoeffPrev, 
    **filterCoeffPrevSelected, *pixAcc;
  static int **filterCoeffSymQuant, first=0;
  double ***E_temp, **y_temp;
  double  pixelDouble, error, errorMin, seOrig, seFilt, lambda, lagrangian, lagrangianMin,  yLocal;
  static imgpel  **imgY_filt, **imgY_pad;
  static double **imgY_preFilter;
  int fl, fl_temp, sqrFiltLength, sqrFiltLength_temp, temp;
  int *pattern, *patternMap, *weights, usePrevFilt[NO_VAR_BINS];
  int numBits, coeffBits;
  double errorForce0CoeffTab[NO_VAR_BINS][2];
  int codedVarBins[NO_VAR_BINS], createBistream /*, forceCoeff0 */;
  static int availableFilters=0, frNoCoded=0;
  int usePrevFiltDefault[NO_VAR_BINS];
  int prevFiltIndDefault=(frNoCoded-1)%NO_PREV_FILTERS;
  double pixAccDefault;
  extern int configurationFlag;

  for (i = 0; i < NO_VAR_BINS; i++)
    usePrevFiltDefault[i]=usePrevFilt[i]=1;

  if(configurationFlag == 0)
    lambda = (qp > 30)? 1 * pow (2, (qp - 12) / 3.0) : 2 * pow (2, (qp - 12) / 3.0);  
  else
    lambda = (qp > 30)? 2 * pow (2, (qp - 12) / 3.0) : 2 * pow (2, (qp - 12) / 3.0);  

  sqrFiltLength=MAX_SQR_FILT_LENGTH;  fl=FILTER_LENGTH/2;

  if (first==0)
  {
    initMatrix_ushort(&imgY_pad, img_height+2*fl, img_width+2*fl);
    initMatrix_ushort(&imgY_filt, img_height, img_width);
    initMatrix_double(&imgY_preFilter, img_height, img_width);

    initMatrix4D_double(&EGlobalSym, NO_TEST_FILT,  NO_VAR_BINS, MAX_SQR_FILT_LENGTH, MAX_SQR_FILT_LENGTH);
    initMatrix3D_double(&yGlobalSym, NO_TEST_FILT, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 

    initMatrix_int(&filterCoeffSymQuant, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 
    initMatrix3D_double(&filterCoeffPrev, NO_PREV_FILTERS, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 
    initMatrix_double(&filterCoeffPrevSelected, NO_VAR_BINS, MAX_SQR_FILT_LENGTH); 
    pixAcc = (double *) calloc(NO_VAR_BINS, sizeof(double));

    filterCoeffDefault = (double *) calloc(MAX_SQR_FILT_LENGTH, sizeof(double));
    filterCoeffDefault[MAX_SQR_FILT_LENGTH - 2] = 1;

    first=1;
  }
  padImage(imgY_rec, imgY_pad, fl, img_height, img_width);

  for (varInd=0; varInd<NO_VAR_BINS; varInd++){
    pixAcc[varInd]=0;
    for (k=0; k<sqrFiltLength; k++){
      yGlobalSym[0][varInd][k]=0;
      for (l=0; l<sqrFiltLength; l++){
        EGlobalSym[0][varInd][k][l]=0;
      }
    }
  }

  for (i = fl; i < img_height+fl; i++){
    for (j = fl; j < img_width+fl; j++){

      varInd=min(varImg[i-fl][j-fl], NO_VAR_BINS-1);
      k=0; memset(ELocal, 0, sqrFiltLength*sizeof(int));

      for (ii=i-fl; ii<=i+fl; ii++){
        for (jj=j-fl; jj<=j+fl; jj++){  
          vectorInd=pattern9x9Sym[k++];
          ELocal[vectorInd]+=imgY_pad[ii][jj];
        }
      }
      ELocal[sqrFiltLength-1]=1;
      yLocal=imgY_org[i-fl][j-fl];

      pixAcc[varInd]+=(yLocal*yLocal);
      for (k=0; k<sqrFiltLength; k++){
        for (l=k; l<sqrFiltLength; l++){
          EGlobalSym[0][varInd][k][l]+=(double)(ELocal[k]*ELocal[l]);
        }
        yGlobalSym[0][varInd][k]+=(double)(ELocal[k]*yLocal);
      }

    }
  }

  // Matrix EGlobalSeq is symmetric, only part of it is calculated
  for (varInd=0; varInd<NO_VAR_BINS; varInd++){
    for (k=1; k<sqrFiltLength; k++){
      for (l=0; l<k; l++){
        EGlobalSym[0][varInd][k][l]=EGlobalSym[0][varInd][l][k];
      }
    }
  }

  if (frNo>0)
  {
    errorMin=0; 
    for (i=0; i<availableFilters; i++){
      error = testPrevFilterFastTestCopy(EGlobalSym[0], yGlobalSym[0], pixAcc, filterCoeffPrev[i], usePrevFilt);
      if (error<errorMin || i==0){
        errorMin=error;
        prevFiltIndDefault=i;
        memcpy(usePrevFiltDefault, usePrevFilt, NO_VAR_BINS*sizeof(int));
      }
    }

    usePrevFilt[0]=0;
    for (i=0; i<availableFilters; i++){
      error = testPrevFilterFastTestCopy(EGlobalSym[0], yGlobalSym[0], pixAcc, filterCoeffPrev[i], usePrevFilt);
      if (error<errorMin){
        errorMin=error;
        prevFiltIndDefault=i;
        memcpy(usePrevFiltDefault, usePrevFilt, NO_VAR_BINS*sizeof(int));
      }
    }

    errorMin=0;
    for (i=0; i<availableFilters; i++){
      error = testPrevFilterFast(EGlobalSym[0], yGlobalSym[0], pixAcc, filterCoeffPrev[i], usePrevFilt);

      if (error<errorMin || i==0){
        errorMin=error;
        (*prevFiltInd)=i;
      }
    }

    error=testPrevFilter(imgY_rec, imgY_org, imgY_pad, varImg, filterCoeffPrev[(*prevFiltInd)], usePrevFiltBest, 
      img_height, img_width);
    preFilterFr(imgY_preFilter, imgY_rec, imgY_org, imgY_pad, varImg, filterCoeffPrev[(*prevFiltInd)], 
      usePrevFiltBest, img_height, img_width);

    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      if (usePrevFiltBest[varInd]==1){
        for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
          filterCoeffPrevSelected[varInd][i]=filterCoeffPrev[(*prevFiltInd)][varInd][i];
        }
      }
      else{
        for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
          filterCoeffPrevSelected[varInd][i]=filterCoeffDefault[i];
        }
      }
    }
  }
  else{
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        filterCoeffPrevSelected[varInd][i]=0;
      }
    }
  }

  // If frNo>0 pixAcc and yGlobalSym have to be calculated again
  if (frNo>0){

    for (varInd=0; varInd<NO_VAR_BINS; varInd++){
      pixAcc[varInd]=0;
      for (k=0; k<sqrFiltLength; k++){
        yGlobalSym[0][varInd][k]=0;
      }
    }

    for (i = fl; i < img_height+fl; i++){
      for (j = fl; j < img_width+fl; j++){

        varInd=min(varImg[i-fl][j-fl], NO_VAR_BINS-1);
        k=0; memset(ELocal, 0, sqrFiltLength*sizeof(int));

        for (ii=i-fl; ii<=i+fl; ii++){
          for (jj=j-fl; jj<=j+fl; jj++){  
            vectorInd=pattern9x9Sym[k++];
            ELocal[vectorInd]+=imgY_pad[ii][jj];
          }
        }
        ELocal[sqrFiltLength-1]=1;
        yLocal=imgY_org[i-fl][j-fl]-imgY_preFilter[i-fl][j-fl];

        pixAcc[varInd]+=(yLocal*yLocal);
        for (k=0; k<sqrFiltLength; k++){
          yGlobalSym[0][varInd][k]+=(double)(ELocal[k]*yLocal);
        }

      }
    }
  }

  for (varInd=0; varInd<NO_VAR_BINS; varInd++){
    cutEy(EGlobalSym[0][varInd], yGlobalSym[0][varInd], EGlobalSym[1][varInd], yGlobalSym[1][varInd],
      MAX_SQR_FILT_LENGTH,  pattern7x7Sym_Quart);
    cutEy(EGlobalSym[0][varInd], yGlobalSym[0][varInd], EGlobalSym[2][varInd], yGlobalSym[2][varInd],
      MAX_SQR_FILT_LENGTH, pattern5x5Sym_Quart);      
  }

  firstFilt=1;  lagrangianMin=0;
  filters_per_fr_best=1;

  for (filtNo=0; filtNo<NO_TEST_FILT; filtNo++){ 

    E_temp=EGlobalSym[filtNo];  y_temp=yGlobalSym[filtNo];
    sqrFiltLength_temp=sqrFiltLengthTab[filtNo]; fl_temp=flTab[filtNo];
    weights=weightsTab[filtNo];

    filters_per_fr=1;
    while(filters_per_fr<=NO_FILTERS){

      findFilterGroupingError(E_temp, y_temp, pixAcc, interval, sqrFiltLength_temp, filters_per_fr);

      findFilterCoeff(E_temp, y_temp, pixAcc, filterCoeffSym, filterCoeffSymQuant, interval,
        varIndTab, sqrFiltLength_temp, filters_per_fr, weights, numBits=NUM_BITS,  errorForce0CoeffTab);

      lagrangian=findBestCoeffCodMethod(bitstream, codedVarBins, forceCoeff0, filterCoeffSymQuant, fl_temp, sqrFiltLength_temp, 
        filters_per_fr, errorForce0CoeffTab, &error, lambda);

      if (lagrangian<lagrangianMin || firstFilt==1){
        firstFilt=0;
        lagrangianMin=lagrangian;

        filters_per_fr_best=filters_per_fr;
        memcpy(intervalBest, interval, NO_VAR_BINS*2*sizeof(int));
        (*filtNo_best)=filtNo;
      }
      filters_per_fr++;
    }

  }

  E_temp=EGlobalSym[(*filtNo_best)];  y_temp=yGlobalSym[(*filtNo_best)];
  sqrFiltLength_temp=sqrFiltLengthTab[(*filtNo_best)]; fl_temp=flTab[(*filtNo_best)];
  weights=weightsTab[(*filtNo_best)];

  findFilterCoeff(E_temp, y_temp, pixAcc, filterCoeffSym, filterCoeffSymQuant, intervalBest,
    varIndTab, sqrFiltLength_temp, filters_per_fr_best, weights, numBits=NUM_BITS, errorForce0CoeffTab);

  findBestCoeffCodMethod(bitstream, codedVarBins, forceCoeff0, filterCoeffSymQuant, fl_temp, sqrFiltLength_temp, 
    filters_per_fr_best, errorForce0CoeffTab, &error, lambda);

  if (frNoCoded>0)
  {
    if (*forceCoeff0==1 && filters_per_fr_best==1){
      coeffBits = codeAuxInfo(-1, filters_per_fr_best, varIndTab, usePrevFiltBest, *prevFiltInd, 
        frNoCoded, bitstream, createBistream=0);
    }
    else{
      coeffBits = codeAuxInfo(*filtNo_best, filters_per_fr_best, varIndTab, usePrevFiltBest, *prevFiltInd, 
        frNoCoded, bitstream, createBistream=0);
    }

    if (*forceCoeff0==0){
      coeffBits += sendAllFiltersPPPred(filterCoeffSymQuant, fl_temp, sqrFiltLength_temp, 
        filters_per_fr_best, bitstream, createBistream=0);
    }
    else{
      coeffBits += sendAllFiltersPPPredForce0(filterCoeffSymQuant, fl_temp, sqrFiltLength_temp, 
        filters_per_fr_best, codedVarBins, bitstream, createBistream=0);
    }

    lagrangianMin=error+lambda*coeffBits;

    preFilterFr(imgY_preFilter, imgY_rec, imgY_org, imgY_pad, varImg, filterCoeffPrev[prevFiltIndDefault], 
      usePrevFiltDefault, img_height, img_width);

    pixAccDefault=0;
    for (i = fl; i < img_height+fl; i++){
      for (j = fl; j < img_width+fl; j++){
        yLocal=imgY_org[i-fl][j-fl]-imgY_preFilter[i-fl][j-fl];
        pixAccDefault+=(yLocal*yLocal);
      }
    }
    coeffBits = codeAuxInfo(-1, filters_per_fr=1, varIndTab, usePrevFiltDefault, prevFiltIndDefault, 
          frNoCoded, bitstream, createBistream=0);
    lagrangian=pixAccDefault+lambda*coeffBits;

    if (lagrangian<lagrangianMin){
      *prevFiltInd=prevFiltIndDefault;
      *forceCoeff0=1; filters_per_fr_best=1;
      memcpy(usePrevFiltBest, usePrevFiltDefault, NO_VAR_BINS*sizeof(int));

      memset(varIndTab, 0, 16*sizeof(int));
      for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
        if (usePrevFiltBest[varInd]==1){
          for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
            filterCoeffPrevSelected[varInd][i]=filterCoeffPrev[(*prevFiltInd)][varInd][i];
          }
        }
        else{
          for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
            filterCoeffPrevSelected[varInd][i]=filterCoeffDefault[i];
          }
        }
      }
    }
  }

  coded=1;
  if (*forceCoeff0==1 && filters_per_fr_best==1){
    coded=0;
    coeffBits = codeAuxInfo(-1, filters_per_fr_best, varIndTab, usePrevFiltBest, *prevFiltInd, 
      frNoCoded, bitstream, createBistream=1);
  }
  else{
    coeffBits = codeAuxInfo(*filtNo_best, filters_per_fr_best, varIndTab, usePrevFiltBest, *prevFiltInd, 
      frNoCoded, bitstream, createBistream=1);
  }

  *codedFlag = coded;

  if (*forceCoeff0==0){
    coeffBits += sendAllFiltersPPPred(filterCoeffSymQuant, fl_temp, sqrFiltLength_temp, 
      filters_per_fr_best, bitstream, createBistream=1);
  }
  else{
    if (filters_per_fr_best==1){
      for(varInd=0; varInd<filters_per_fr_best; varInd++){
        for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
          filterCoeffSym[varInd][i]=0;
        }
      }
    }
    else{
      coeffBits += sendAllFiltersPPPredForce0(filterCoeffSymQuant, fl_temp, sqrFiltLength_temp, 
        filters_per_fr_best, codedVarBins, bitstream, createBistream=1);

      for(varInd=0; varInd<filters_per_fr_best; varInd++){
        if (codedVarBins[varInd]==0){
          for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
            filterCoeffSym[varInd][i]=0;
          }
        }
      }
    }
  }

  updateBits(&psnrBitsRes, coeffBits);

  if (frNo>0){
    patternMap=patternMapTab[(*filtNo_best)];
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      k=0;
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        if (patternMap[i]>0){
          filterCoeffPrevSelected[varInd][i]+=filterCoeffSym[varIndTab[varInd]][k];
          k++;
        }
      }
    }
  }
  else{
    patternMap=patternMapTab[(*filtNo_best)];
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      k=0;
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        if (patternMap[i]>0){
          filterCoeffPrevSelected[varInd][i]=filterCoeffSym[varIndTab[varInd]][k];
          k++;
        }
      }
    }
  }

  pattern=patternTab[0];
  sqrFiltLength_temp=sqrFiltLengthTab[0]; fl_temp=flTab[0];
  // Filter
  seFilt=0; seOrig=0;

  for (i = fl; i < img_height+fl; i++){
    for (j = fl; j < img_width+fl; j++){

      varInd=min(varImg[i-fl][j-fl],NO_VAR_BINS-1);
      pixelDouble=0; k=0;

      for (ii=i-fl_temp; ii<=i+fl_temp; ii++){
        for (jj=j-fl_temp; jj<=j+fl_temp; jj++){  
          vectorInd=pattern[k++];
          pixelDouble+=(imgY_pad[ii][jj]*filterCoeffPrevSelected[varInd][vectorInd]);
        }
      }
      pixelDouble+=filterCoeffPrevSelected[varInd][sqrFiltLength_temp-1];
      pixelInt=(int)floor(pixelDouble+0.5);

      imgY_filt[i-fl][j-fl]=max(0, min(pixelInt,255));
      temp=(imgY_filt[i-fl][j-fl]-imgY_org[i-fl][j-fl]);
      seFilt+=temp*temp;
      temp=(imgY_rec[i-fl][j-fl]-imgY_org[i-fl][j-fl]);
      seOrig+=temp*temp;
    }
  }

#if DEBUGGING==0
  if (seFilt<seOrig){ 
    for (i = 0; i < img_height; ++i){
      for (j = 0; j < img_width; ++j){
        imgY_rec[i][j]=imgY_filt[i][j];
      }
    }
  }
#endif

  if (coded==1){
    for(varInd=0; varInd<NO_VAR_BINS; ++varInd){    
      for(i = 0; i < MAX_SQR_FILT_LENGTH; i++){
        filterCoeffPrev[frNoCoded%NO_PREV_FILTERS][varInd][i]=filterCoeffPrevSelected[varInd][i];
      }
    }
    availableFilters++; frNoCoded++;
    availableFilters=min(NO_PREV_FILTERS-1,availableFilters);
  }

  return(seFilt);

}





